% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cbGet-methods.R
\docType{methods}
\name{cbGet,CellBaseR-method}
\alias{cbGet}
\alias{cbGet,CellBaseR-method}
\title{The generic method for cbGet This method allows the user to query the cellbase web services without any 
predefined categories, subcategries, or resources. Please, for details on possible values for the parameters and 
additional filters of this function refer to https://github.com/opencb/cellbase/wiki and the RESTful API documentation 
http://bioinfo.hpc.cam.ac.uk/cellbase/webservices/}
\usage{
\S4method{cbGet}{CellBaseR}(object, category, subcategory, ids, resource,
  filters = NULL, ...)
}
\arguments{
\item{object}{an object of class CellBaseR}

\item{category}{character to specify the category to be queried.}

\item{subcategory}{character to specify the subcategory to be queried}

\item{ids}{a character vector of the ids to be queried}

\item{resource}{a character to specify the resource to be queried}

\item{filters}{an object of class CellBaseParam specifying additional filters for the CellBaseR}

\item{...}{any extra arguments}
}
\value{
an object of class CellBaseResponse which holds a dataframe
}
\description{
The generic method for cbGet This method allows the user to query the cellbase web services without any 
predefined categories, subcategries, or resources. Please, for details on possible values for the parameters and 
additional filters of this function refer to https://github.com/opencb/cellbase/wiki and the RESTful API documentation 
http://bioinfo.hpc.cam.ac.uk/cellbase/webservices/
}
\examples{
   cb <- CellBaseR()
   res <- cbGet(object=cb, category="feature", subcategory="gene", ids="TET1", resource="info")
}

