/*
 * Copyright 2015-2020 OpenCB
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.opencb.cellbase.core.common.regulatory;

// Generated Jun 5, 2012 6:41:13 PM by Hibernate Tools 3.4.0.CR1

import java.util.HashSet;
import java.util.Set;

/**
 * RegulatoryRegion generated by hbm2java.
 */
public class RegulatoryRegion implements java.io.Serializable {

    private int regulatoryRegionId;
    private String name;
    private String type;
    private String chromosome;
    private int start;
    private int end;
    private double experimentalScore;
    private String cellType;
    private String cellTypeDescription;
    private String source;
    private Set<Tfbs> tfbses = new HashSet<Tfbs>(0);

    public RegulatoryRegion() {
    }

    public RegulatoryRegion(int regulatoryRegionId, String name, String type, String chromosome, int start, int end,
                            double experimentalScore, String cellType, String cellTypeDescription, String source) {
        this.regulatoryRegionId = regulatoryRegionId;
        this.name = name;
        this.type = type;
        this.chromosome = chromosome;
        this.start = start;
        this.end = end;
        this.experimentalScore = experimentalScore;
        this.cellType = cellType;
        this.cellTypeDescription = cellTypeDescription;
        this.source = source;
    }

    public RegulatoryRegion(int regulatoryRegionId, String name, String type, String chromosome, int start, int end,
                            double experimentalScore, String cellType, String cellTypeDescription, String source, Set<Tfbs> tfbses) {
        this.regulatoryRegionId = regulatoryRegionId;
        this.name = name;
        this.type = type;
        this.chromosome = chromosome;
        this.start = start;
        this.end = end;
        this.experimentalScore = experimentalScore;
        this.cellType = cellType;
        this.cellTypeDescription = cellTypeDescription;
        this.source = source;
        this.tfbses = tfbses;
    }

    public int getRegulatoryRegionId() {
        return this.regulatoryRegionId;
    }

    public void setRegulatoryRegionId(int regulatoryRegionId) {
        this.regulatoryRegionId = regulatoryRegionId;
    }

    public String getName() {
        return this.name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getType() {
        return this.type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public String getChromosome() {
        return this.chromosome;
    }

    public void setChromosome(String chromosome) {
        this.chromosome = chromosome;
    }

    public int getStart() {
        return this.start;
    }

    public void setStart(int start) {
        this.start = start;
    }

    public int getEnd() {
        return this.end;
    }

    public void setEnd(int end) {
        this.end = end;
    }

    public double getExperimentalScore() {
        return this.experimentalScore;
    }

    public void setExperimentalScore(double experimentalScore) {
        this.experimentalScore = experimentalScore;
    }

    public String getCellType() {
        return this.cellType;
    }

    public void setCellType(String cellType) {
        this.cellType = cellType;
    }

    public String getCellTypeDescription() {
        return this.cellTypeDescription;
    }

    public void setCellTypeDescription(String cellTypeDescription) {
        this.cellTypeDescription = cellTypeDescription;
    }

    public String getSource() {
        return this.source;
    }

    public void setSource(String source) {
        this.source = source;
    }

    public Set<Tfbs> getTfbses() {
        return this.tfbses;
    }

    public void setTfbses(Set<Tfbs> tfbses) {
        this.tfbses = tfbses;
    }

}
